statemachine("Workflow for branch", "Branch").addRequirements(requirements([{name: "Issue", fields: [{name: "State", type: {name: "State", values: ["Fixed", "Verified"]}}, {name: "Code reviewer", type: {name: "User"}}, {name: "Type", type: {name: "EnumField", values: ["Hotfix"]}}, {name: "project", type: {name: "Project", fields: [{name: "leader", type: {name: "User", methods: [{name: "notify", returnType: {name: "void"}, paramTypes: [{name: "string"}, {name: "string"}]}]}}]}}, {name: "Assignee", type: {name: "User"}}, {name: "summary", type: {name: "string", primitive: true}}, {name: "Tester", type: {name: "User"}}, {name: "Branch", type: {name: "EnumField", values: ["Ticket", "Integration", "Release candidate", "Master"]}}]}]));
from("Ticket").on("merge to integration").perform(function(ctx) {
  assert(ctx, equals(safeCall(ctx.issue,"get", ["State"]), find("Fixed")),"Only fixed tickets can be sent to integration branch for testing.");
  assert(ctx, !equals(safeCall(ctx.issue,"get", ["Code reviewer"]), null),"Only reviewed tickets can be sent to integration branch for testing.");
  assert(ctx, !equals(safeCall(ctx.issue,"get", ["Type"]), find("Hotfix")),"Hotfixes don't go through integration and rc workflow. Please merge it directly to master and change branch in YT to master.");
  assert(ctx, equals(ctx.loggedInUser, safeCall(ctx.issue,"get", ["Assignee"])) || equals(ctx.loggedInUser, safeCall(safeCall(ctx.issue,"get", ["project"]),"get", ["leader"])),"Only assignee or project leader can merge this ticket to integration.");
  message(ctx,"Ticket moved to integration branch in YT, you should now merge it from ticket to integration branch in GIT.");
  if (equals(safeCall(ctx.issue,"get", ["Tester"]), null)) {
    invoke(ctx, safeCall(safeCall(ctx.issue,"get", ["project"]),"get", ["leader"]), "notify", ["[TESTER] " + invoke(ctx, ctx.issue, "getId", []) + ": " + safeCall(ctx.issue,"get", ["summary"], null),invoke(ctx, ctx.issue, "getUrl", [])]);
  }
}).transitTo("Integration");
from("Ticket").on("merge to master").perform(function(ctx) {
  assert(ctx, equals(safeCall(ctx.issue,"get", ["Type"]), find("Hotfix")),"Only hotfixes can be sent to master directly from ticket branches.");
  assert(ctx, equals(safeCall(ctx.issue,"get", ["State"]), find("Fixed")),"Only fixed hotfixes can be sent to master to be released.");
  assert(ctx, equals(ctx.loggedInUser, safeCall(ctx.issue,"get", ["Assignee"])) || equals(ctx.loggedInUser, safeCall(safeCall(ctx.issue,"get", ["project"]),"get", ["leader"])),"Only assignee or project leader can merge this ticket to master.");
  message(ctx,"Ticket moved to master branch in YT, you should now merge it from ticket to master branch in GIT.");
  invoke(ctx, safeCall(safeCall(ctx.issue,"get", ["project"]),"get", ["leader"]), "notify", ["[HOTFIX TO DEPLOY] " + invoke(ctx, ctx.issue, "getId", []) + ": " + safeCall(ctx.issue,"get", ["summary"], null),invoke(ctx, ctx.issue, "getUrl", [])]);
}).transitTo("Master");
from("Integration").on("merge to release candidate").perform(function(ctx) {
  assert(ctx, equals(ctx.loggedInUser, safeCall(safeCall(ctx.issue,"get", ["project"]),"get", ["leader"])),"Only project leader can merge integration tickets to release candidate branch.");
}).transitTo("Release candidate");
from("Release candidate").on("merge to master").perform(function(ctx) {
  assert(ctx, equals(ctx.loggedInUser, safeCall(safeCall(ctx.issue,"get", ["project"]),"get", ["leader"])),"Only project leader can merge release candidate tickets to master.");
  assert(ctx, equals(safeCall(ctx.issue,"get", ["State"]), find("Verified")),"Only verified tickets can be merged to master and released.");
}).transitTo("Master");
from("Master");